<?php
require_once('include/MVC/View/SugarView.php');

class SearchNameViewMysearch1 extends SugarView {
	private $module_names = array("Accounts", "Contacts", "Leads", "Prospects", "Users");

	function process() {
		if(!isset($_GET['number'])){
			return;
		}
		$number = $_GET['number'];
		if (strlen($number) == 12 && $number[0] == "+" && $number[1] == "1") {
			$number = substr($number, 2);
		} else if (strlen($number) == 11 && $number[0] == "1") {
			$number = substr($number, 1);
		}

		$output = array();
		array_push($output, array('phone' => $number, 'isAdmin' => $GLOBALS['current_user']->isAdmin()));

		// Format the number for searching
		if ($number[0] == "+")
			$number = substr($number, 1);
		if (strlen($number) > 6) // For external numbers
			$number = $this->create_number_with_wildcard($number);

		foreach ($this->module_names as $module_name) {
			$field_names = ($module_name == "Accounts" ? array("phone_office", "phone_alternate") : array("phone_work", "phone_home", "phone_mobile", "phone_other"));
			$class = $GLOBALS['beanList'][$module_name];
			$bean = new $class;
			$query = $this->build_query($bean->table_name, $field_names, $number);
			$order_by = "";
			$response = $bean->get_list($order_by, $query);
			$list = $response['list'];
			if ($response['list'] != null) {
				foreach ($response['list'] as $obj) {
					array_push($output, array('name' => $obj->name, 'type' => $module_name, 'id' => $obj->id));
				}
			}
		}
		echo json_encode($output);
	}

	function create_number_with_wildcard($number) {
		$result = "%";
		for($i = 0, $j = strlen($number); $i < $j; $i++) {
			$result .= $number[$i]."%";
		}
		return $result;
	}

	function build_query($table_name, $field_names, $value) {
		$query = "";
		foreach($field_names as $field_name) {
			$s = $table_name . "." . $field_name . " LIKE '" . $value . "'";
			if ($query !== "") {
				$query .= " or ";
			}
			$query .= $s;
		}
		return $query;
	}
}
?>
