

var c2PopConfig = {
	"Callbacks": {
		"IncomingHandler": "Click2PopIncomingHandler",
		"OutgoingHandler": "Click2PopOutgoingHandler"
	}
};
 
function Click2PopIncomingHandler(phone) {
    
	click2PopSugar.callHandler(phone, true);
}

function Click2PopOutgoingHandler(phone) {
   
	click2PopSugar.callHandler(phone, false);
}

function Click2PopSugar(){
	this.callers = [];
}

Click2PopSugar.prototype.getSingularString = function(str) {
    if (str.substring(str.length - 1) === "s"){
		return str.substring(0, str.length - 1);
	}
    return str;
};

Click2PopSugar.prototype.getCreateButtonHtml = function(module, phoneVar, label) {
	var singularString = click2PopSugar.getSingularString(module);
	if (label === null){
		label = singularString;
	}
	return "<TD><button id=\"vo8x8-btn-create-" + singularString.toLowerCase() + "\" class=\"vo8x8-btn\" onClick=\"click2PopSugar.createProfile('" + module + "', '" + phoneVar + "');\">Create " + label + "</button></TD>";
};

Click2PopSugar.prototype.callHandler = function(phone, inbound) {
	var url = "index.php?module=SearchName&action=Search1&number=" + phone;
	var callback = {
		success: (inbound ? click2PopSugar.handleSuccessInbound : click2PopSugar.handleSuccessOutbound),
		failure: click2PopSugar.handleFailure,
		timeout: 5000
	};

	YAHOO.util.Connect.asyncRequest("GET", url, callback);
};

Click2PopSugar.prototype.handleSuccess = function(res, inbound) {
	click2PopSugar.callers = YAHOO.lang.JSON.parse(res.responseText);
	if (click2PopSugar.callers instanceof Array){
		if (click2PopSugar.callers.length > 0) {
			click2PopSugar.popup(inbound);
		}
	}
};

Click2PopSugar.prototype.handleSuccessInbound = function(res) {
	click2PopSugar.handleSuccess(res, true);
};

Click2PopSugar.prototype.handleSuccessOutbound = function(res) {
	click2PopSugar.handleSuccess(res, false);
};

Click2PopSugar.prototype.handleFailure = function(res) {
	click2PopSugar.callers = [];
};

Click2PopSugar.prototype.popup = function(inbound) {
	var msg;
	var colspan;
	if (click2PopSugar.callers.length > 1){
		colspan = 3;
		msg = "";
		for (var i = 1; i < click2PopSugar.callers.length; i++){
			var label = click2PopSugar.getSingularString(click2PopSugar.callers[i].type);
			if (label === "Prospect"){
				label = "Target";
			}
			msg += ("<TR>" +
						"<TD ALIGN=\"LEFT\">" + click2PopSugar.callers[i].name + "</TD>" +
						"<TD ALIGN=\"RIGHT\"><button id=\"vo8x8-btn-open" + i + "\" class=\"vo8x8-btn\" onClick=\"click2PopSugar.openProfile(" + i + ");\">Open " + label + "</button></TD>" +
						"<TD><button id=\"vo8x8-btn-logcall" + i + "\" class=\"vo8x8-btn\" onClick=\"click2PopSugar.logCall(" + i + ", " + inbound + ");\">Log Call</button></TD>" +
					"</TR>");
		}
	} else {
		msg = "<TR>" +
			click2PopSugar.getCreateButtonHtml("Accounts", "phone_office", null) +
			click2PopSugar.getCreateButtonHtml("Contacts", "phone_work", null) +
			click2PopSugar.getCreateButtonHtml("Leads", "phone_work", null) +
			click2PopSugar.getCreateButtonHtml("Prospects", "phone_work", "Target");
		if (click2PopSugar.callers[0].isAdmin){
			msg += click2PopSugar.getCreateButtonHtml("Users", "phone_work", "New User");
			colspan = 5;
		} else {
			colspan = 4;
		}
		msg += "</TR>";
	}
	var msgTitle = inbound ? "Incoming call from" : "Outgoing call to";
	msg = "<TABLE BORDER=\"0\" WIDTH=\"100%\" cellpadding=\"4\" class=\"vo8x8-std-text\"><TBODY><TR><TD ALIGN=\"LEFT\" colspan=\"" + colspan + "\">" + msgTitle + " " + click2PopSugar.callers[0].phone + "</TD></TR>" + msg + "</TBODY></TABLE>";

	this.openDialog("vo8x8-popup-dialog");
	document.getElementById("vo8x8-popup-msg").innerHTML = msg;
	setTimeout("click2PopSugar.closePopup();", 15000);
};

Click2PopSugar.prototype.openProfile = function(index) {
	window.open("index.php?module=" + click2PopSugar.callers[index].type + "&action=DetailView&record=" + click2PopSugar.callers[index].id);
};

Click2PopSugar.prototype.logCall = function(index, inbound) {
	var direction = inbound ? "Inbound" : "Outbound";
	window.open("index.php?module=Calls&action=EditView&status=Held&direction=" + direction + "&reminder_checked=0&parent_type=" +
			click2PopSugar.callers[index].type +
			"&parent_id=" + click2PopSugar.callers[index].id +
			"&parent_name=" + encodeURIComponent(click2PopSugar.callers[index].name));
};

Click2PopSugar.prototype.createProfile = function(module, phoneVar) {
	var phoneVal = click2PopSugar.callers[0].phone;
	if (phoneVal.length == 11){
		if (phoneVal.substring(0, 1) === "1"){
			phoneVal = phoneVal.substring(1);
		}
	}
	if (phoneVal.length == 10){
		phoneVal = "(" + phoneVal.substring(0, 3) + ") " + phoneVal.substring(3, 6) + "-" + phoneVal.substring(6);
	}
	window.open("index.php?module=" + module + "&action=EditView&" + phoneVar + "=" + encodeURIComponent(phoneVal));
};

Click2PopSugar.prototype.closePopup = function() {
	this.closeDialog("vo8x8-popup-dialog");
};

Click2PopSugar.prototype.openDialog = function(id) {
	var dialog = document.getElementById(id);
	dialog.style.top = (document.getElementById("dcmenu") !== null ? "46px" : "2px");
	dialog.style.visibility = "visible";
};

Click2PopSugar.prototype.closeDialog = function(id) {
	var dialog = document.getElementById(id);
	dialog.style.visibility = "hidden";
};

Click2PopSugar.prototype.buildUI = function() {
	if (document.getElementById("vo8x8-popup-dialog") !== null) {
		return;
	}

	var body = document.getElementsByTagName("body")[0];
	var div = document.createElement("div");
	div.id = "c2pdialog";
	div.innerHTML =
		"<div id=\"vo8x8-popup-dialog\" class=\"vo8x8-dialog\" style=\"visibility:hidden;\">" +
			"<div class=\"vo8x8-dialog-header\">" +
				"<img onclick=\"click2PopSugar.closeDialog('vo8x8-popup-dialog')\" src=\"custom/themes/default/images/cross-button.png\"/>" +
				"<span style=\"position:relative;left:4px;top:-3px;\">8x8 Click2Pop</span>" +
			"</div>" +
			"<div id=\"vo8x8-popup-msg\"></div>" +
		"</div>";
	body.appendChild(div);
};

Click2PopSugar.prototype.loadUI = function() {
	if ( document.readyState === "complete" ) {
		setTimeout(click2PopSugar.buildUI, 1);
		return;
	}
	if ( document.addEventListener ) {
		document.addEventListener( "DOMContentLoaded", click2PopSugar.buildUI, false );
		window.addEventListener( "load", click2PopSugar.buildUI, false );
	} else if ( document.attachEvent ) {
		document.attachEvent( "onreadystatechange", click2PopSugar.buildUI );
		window.attachEvent( "onload", click2PopSugar.buildUI);
	}
};

var click2PopSugar = new Click2PopSugar();
click2PopSugar.loadUI();
